<template>
  <div v-if="!packages.length" class="not-found text-secondary">Not Found</div>

  <div v-if="packages.length" class="table">
    <button
      v-if="packages.length >= 10"
      class="table__arrow table__arrow-prev"
      v-bind:class="{ 'is-disabled': page === 1 }"
      v-on:click="clickPrev"
    ></button>

    <div class="table__header">
      <span class="table__header-cell">Name</span>

      <span class="table__header-cell">Description</span>
    </div>

    <div
      class="table__package border-1"
      v-for="(item, index) in packages"
      :key="index"
      @click="packageClick(item.package)"
    >
      <span class="table__package-cell table__package-name text-secondary">
        {{ item.package.name }}
      </span>

      <span
        class="table__package-cell table__package-description text-secondary"
      >
        {{
          item.package.description ? item.package.description : "No Description"
        }}
      </span>
    </div>

    <button
      v-if="packages.length >= 10"
      class="table__arrow table__arrow-next"
      v-bind:class="{ 'is-disabled': page === 10 }"
      v-on:click="clickNext"
    ></button>
  </div>
</template>

<script>
export default {
  name: "TablePanel",
  props: ["request"],
  emits: ["click"],
  data: () => {
    return {
      allPackages: [],
      packages: [],
      page: 1,
    };
  },
  watch: {
    request: async function () {
      if (!this.currentRequest) {
        this.packages = [];
        return;
      }

      const response = await fetch(
        `https://registry.npmjs.com/-/v1/search?text=${this.currentRequest}&from=0&size=100&quality=0.0&maintenance=0.0&popularity=1.0`
      );
      const data = await response.json();
      this.allPackages = data.objects;
      this.packages = this.allPackages.slice(0, 10);
    },
  },
  computed: {
    currentRequest: function () {
      if (!this.request) {
        return "";
      }

      const onlyCharsString = this.request.trim();
      return onlyCharsString.length === 1 ? "" : onlyCharsString;
    },
  },
  methods: {
    packageClick(data) {
      this.$emit("click", data);
    },
    clickNext() {
      this.packages = this.allPackages.slice(
        this.page * 10,
        (this.page + 1) * 10
      );
      this.page += 1;
    },
    clickPrev() {
      this.packages = this.allPackages.slice(
        (this.page - 2) * 10,
        (this.page - 1) * 10
      );
      this.page -= 1;
    },
  },
};
</script>

<style scoped lang="scss">
.not-found {
  font-size: 30px;
  font-weight: 600;
  color: green;
}

.table {
  max-width: 1000px;
  margin: 0 auto;
  padding: 0 40px;
  position: relative;

  @media only screen and (max-width: "550px") {
    padding: 0 15px 110px;
  }

  &__arrow {
    position: absolute;
    top: 50%;
    width: 0;
    height: 0;
    border: 0;
    border-bottom: 37px solid #007bff;
    border-right: 37px solid transparent;
    border-top: 0 !important;
    transition: border-width 300ms ease-in;
    background: transparent;
    display: block;
    padding: 0;
    cursor: pointer;
    transition: border-color 300ms ease-in;

    @media only screen and (max-width: "550px") {
      top: unset;
      bottom: 20px;
      border-bottom-width: 70px;
      border-right-width: 70px;
    }

    &.is-disabled {
      opacity: 0.3;
      pointer-events: none;
    }

    &:hover {
      border-bottom-color: #05107b;
      transition: border-color 300ms ease-out;
    }

    &-next {
      right: 15px;
      transform: rotate(-135deg);

      @media only screen and (max-width: "550px") {
        right: 30px;
      }
    }

    &-prev {
      left: 15px;
      transform: rotate(45deg);

      @media only screen and (max-width: "550px") {
        left: 30px;
      }
    }
  }

  &__header {
    display: grid;
    grid-template-columns: 40% 60%;
    height: 30px;
    align-items: center;
    font-size: 20px;
    font-weight: 500;
    text-transform: uppercase;
    border: 0;
  }

  &__package {
    margin: 0;
    height: 50px;
    align-items: center;
    display: grid;
    grid-template-columns: 40% 60%;
    cursor: pointer;
    position: relative;
    border-style: solid;

    &:hover {
      &::before {
        opacity: 0.1;
        transition: opacity 300ms ease-out;
      }
    }

    &::before {
      content: "";
      position: absolute;
      left: 0;
      right: 0;
      top: 0;
      bottom: 0;
      background: #2196f3;
      opacity: 0.03;
      z-index: 0;
      transition: opacity 300ms ease-in;
    }

    &:not(:last-of-type) {
      border-bottom: 0;
    }

    &:first-child {
      border-radius: 5px 5px 0 0;
    }

    &:last-child {
      border-radius: 0 0 5px 5px;
    }

    &-cell {
      font-size: 20px;
      line-height: 50px;
      height: 100%;
      display: block;
      padding: 0 10px;
      z-index: 1;
      position: relative;
      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;

      @media only screen and (max-width: "550px") {
        font-size: 16px;
      }

      &:not(:first-child) {
        border-left: 1px solid #000;
      }
    }
  }
}
</style>
